struc	fdbgDriverQuery
{
.iocode				dd	?	; user I/O code
.version			dd	?
.flags0				dd	?	; flag for DebugCtlMSR register status
.flags1				dd	?	; flag for hooked interrupts status
.DebugCtlMSRLo			dd	?
.DebugCtlMSRHi			dd	?
.dummy				dq	?	; reserved for feature usage
; note, following must be aligned 16 to copy them at double speed using xmm registers
.LastBranchFromIP		dq	?
.LastBranchToIP			dq	?
.LastExceptionFromIP		dq	?
.LastExceptionToIP		dq	?
size_of_fdbgDriverQuery		=	$ - $$
}

; values for iocode (user I/O code) used for communicate with write_device.exe
DRIVER_QUERY_START		=	7F000000h + 'FG'*100h
DRIVER_Get_Version		=	DRIVER_QUERY_START + 00h
DRIVER_Get_Flags		=	DRIVER_QUERY_START + 01h
DRIVER_Get_DebugCtlMSR		=	DRIVER_QUERY_START + 02h
DRIVER_Set_DebugCtlMSR		=	DRIVER_QUERY_START + 03h
DRIVER_EnableBranchesRecording	=	DRIVER_QUERY_START + 04h
DRIVER_DisableBranchesRecording	=	DRIVER_QUERY_START + 05h
DRIVER_EnableStepOnBranches	=	DRIVER_QUERY_START + 06h
DRIVER_DisableStepOnBranches	=	DRIVER_QUERY_START + 07h
DRIVER_HookExceptionVectors	=	DRIVER_QUERY_START + 08h
DRIVER_UnhookExceptionVectors	=	DRIVER_QUERY_START + 09h
DRIVER_Get_BranchesMSRs		=	DRIVER_QUERY_START + 0Ah
